/*
© Copyright CERN 2000-2018. All rigths reserved. This software is released under a CERN proprietary software licence.
Any permission to use it shall be granted in writing. Request shall be adressed to CERN through mail-KT@cern.ch
*/

#ifndef CHABAGRAPHICALWIDGET_HPP
#define CHABAGRAPHICALWIDGET_HPP

#include <memory>

#include <editors/script/EditorScriptWidgets.hpp>

class ChabaProject;

/**
 * Graphical interface for Chaba Plugin.
 *
 * This interface implements the graphical interface for SurveyPad plugins.
 *
 * It is composed of multiple tabs, showing an input or output file:
 * - project tab shows the .chaba project file in a ChabaProjectEditor
 * - active (reference) points tab shows the active points file in a ChabaPointText
 * - passive points tab shows the passive points file in a ChabaPointText
 * - output tab shows the result file in a ChabaOutputText
 * - coo tab shows the coo result file in a ChabaOutputText
 * - punch tab shows the punch result file in a ChabaOutputText
 * - log tab shows the logs in a ChabaOutputText
 */
class ChabaGraphicalWidget : public TabEditorScriptWidget
{
	Q_OBJECT

public:
	ChabaGraphicalWidget(SPluginInterface *owner, QWidget *parent = nullptr);
	virtual ~ChabaGraphicalWidget() override;

	// SGraphicalWidget
	virtual QString getPath() const override;

public slots:
	// SGraphicalWidget
	virtual void aboutTorun() override;
	virtual void runFinished(bool status) override;
	// STabInterface
	virtual void clearContent() override;

	/** Import active points file and show them in active points tab. */
	void importActive();
	/** Import passive points file and show them in passive points tab. */
	void importPassive();

protected:
	// STabInterface
	virtual bool _save(const QString &path) override;
	virtual bool _open(const QString &path) override;
	virtual void _newEmpty() override;

private:
	/** Open the output files generated by Chaba and show them if possible */
	void openOutputs(const ChabaProject &project, bool onlyLog = false);
	/** Remove the outputs tabs, generally before a new Chaba run */
	void removeOutputs();
	/** @return the full path of a file, assuming the file is located next to the project file */
	QString getFullPath(const std::string &file);
	/** update the window title with the name of the project file */
	void updateWindowTitle();
	/** @return if update of project file names was successful */
	bool updateProjectPaths(const std::string &filename);

	/** Setup of Chaba editors. */
	void setupEditors();
	/** Setup of Chaba specific actions. */
	void setupActions();
	/** Setup of entry points - provided they are available. */
	void setupEntryPoints();

private slots:
	void globalIndicatorClicked(const QString &, int position);
	void tabHasChanged(int pos);
	void inputHasChanged();

private:
	/** pimpl */
	class _ChabaGraphicalWidget_pimpl;
	std::unique_ptr<_ChabaGraphicalWidget_pimpl> _pimpl;
};

#endif // CHABAGRAPHICALWIDGET_HPP
